Lattice Grid Buy a licence

vue data grid · data router

Vue Grid: Data Router

One feed, split across as many grids as you want by a key on each record, provided from one setup call. Neither grid below owns its own fetch or its own WebSocket; each just names the route it wants.

Also in: React Angular Svelte

Install and import

npm install @toclocoinc/lattice-grid
# free on localhost; a production domain needs a licence key (see /pricing/)

The files

lattice.js

// lattice.js, built once at module scope
import * as vue from 'vue';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import { createDataRouter } from '@toclocoinc/lattice-grid/modules/data-router';
import { createLatticeVue } from '@toclocoinc/lattice-grid/modules/vue';

export const L = createLatticeVue({ vue, createGrid, createDataRouter });

Orders.vue

<!-- Orders.vue -->
<script setup>
import { L } from './lattice';

// Scoped to this component: built once on first use, destroyed with it -
// rebuilding on every render would drop every attached grid and every row
// it holds.
L.provideLatticeRouter({ key: 'type', rowKey: 'id' });

const MONEY = { style: 'currency', currency: 'USD', decimals: 0 };
const orderColumns = [
  { field: 'id', title: 'Ref', layout: { width: 110, pin: 'start' } },
  { field: 'region', title: 'Region', filter: { type: 'set' } },
  { field: 'service', title: 'Service', filter: { type: 'set' } },
  { field: 'value', title: 'Value', type: 'number', format: MONEY, total: 'sum' },
];
const returnColumns = orderColumns.map((c) => (c.field === 'value' ? { ...c, title: 'Refund' } : c));
</script>

<template>
  <div style="display:grid;grid-template-columns:1fr 1fr;gap:14px">
    <component :is="L.LatticeGrid" route="order" row-key="id" selection="multiple"
               :highlight-on-change="{ duration: 500 }" :columns="orderColumns" :rows="[]"
               style="height: 320px" />
    <component :is="L.LatticeGrid" route="return" row-key="id"
               :highlight-on-change="{ duration: 500 }" :columns="returnColumns" :rows="[]"
               style="height: 320px" />
  </div>
</template>

See it running

Building…
Loading a live grid…

Open this demo's Vue tab →

Working in Vue

The router belongs to the component that provides it. L.provideLatticeRouter(config) is called once in setup (or the top level of <script setup>); the router is built lazily by the first <component :is="L.LatticeGrid" route="…"> beneath it and destroyed when this component's scope is disposed.

The config is read once. Rebuilding the router would drop every attached grid and every row it holds, so it is not reactive: pass a plain object, not a ref you intend to mutate.

<component :is="…">, not a named import. Because createLatticeVue builds its components dynamically from the factories you pass, they are referenced as L.LatticeGrid through the dynamic component binding rather than imported directly by name.

Related

Lattice Grid Buy a licence

angular data grid · data router

Angular Grid: Data Router

One feed, split across as many grids as you want by a key on each record, provided as a service scoped to one component. Neither grid below owns its own fetch or its own WebSocket; each just names the route it wants.

Also in: React Vue Svelte

Install and import

npm install @toclocoinc/lattice-grid
# free on localhost; a production domain needs a licence key (see /pricing/)

The files

orders.component.ts

// orders.component.ts
import { Component } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import { createDataRouter } from '@toclocoinc/lattice-grid/modules/data-router';
import { LatticeGridComponent, provideLattice, provideLatticeRouter } from '@toclocoinc/lattice-grid/angular';

const MONEY = { style: 'currency', currency: 'USD', decimals: 0 };
const ORDER_COLUMNS = [
  { field: 'id', title: 'Ref', layout: { width: 110, pin: 'start' } },
  { field: 'region', title: 'Region', filter: { type: 'set' } },
  { field: 'service', title: 'Service', filter: { type: 'set' } },
  { field: 'value', title: 'Value', type: 'number', format: MONEY, total: 'sum' },
];
const RETURN_COLUMNS = ORDER_COLUMNS.map((c) => (c.field === 'value' ? { ...c, title: 'Refund' } : c));

@Component({
  selector: 'app-orders',
  standalone: true,
  imports: [LatticeGridComponent],
  // Scoped to this component: built once on first use, destroyed with it.
  providers: [provideLatticeRouter({ key: 'type', rowKey: 'id' })],
  template:
    '<div style="display:grid;grid-template-columns:1fr 1fr;gap:14px">' +
    '  <lattice-grid route="order" [config]="orderConfig" style="display:block;height:320px"></lattice-grid>' +
    '  <lattice-grid route="return" [config]="returnConfig" style="display:block;height:320px"></lattice-grid>' +
    '</div>',
})
export class OrdersComponent {
  orderConfig = { rowKey: 'id', selection: 'multiple', highlightOnChange: { duration: 500 }, columns: ORDER_COLUMNS, rows: [] };
  returnConfig = { rowKey: 'id', highlightOnChange: { duration: 500 }, columns: RETURN_COLUMNS, rows: [] };
}

bootstrapApplication(OrdersComponent, {
  providers: [provideLattice({ createGrid, createDataRouter })],
});

See it running

Building…
Loading a live grid…

Open this demo's Angular tab →

Working in Angular

The router is a provider, not a field you build. provideLatticeRouter(cfg) goes in the component's own providers array; it is created when the first <lattice-grid route="…"> beneath it attaches, and destroyed with that component, so it lives exactly as long as the screen that owns it.

The config is read once. Rebuilding the router mid-life would drop every attached grid and every row it holds, which is also why it is scoped per-component rather than provided at the root.

Each grid detaches before it is destroyed, in ngOnDestroy, so the router this component provides never ends up holding a reference to a grid that no longer exists.

Related

Lattice Grid Buy a licence

react data grid · data router

React Grid: Data Router

One feed, split across as many grids as you want by a key on each record. Push a record into the router and it lands, updates or leaves the right grid on its own; neither grid below owns its own fetch or its own WebSocket.

Also in: Angular Vue Svelte

Install and import

npm install @toclocoinc/lattice-grid
# free on localhost; a production domain needs a licence key (see /pricing/)

The files

lattice.ts

// lattice.ts
import React from 'react';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import { createDataRouter } from '@toclocoinc/lattice-grid/modules/data-router';
import { createLatticeReact } from '@toclocoinc/lattice-grid/modules/react';

export const { LatticeGrid, useLatticeRouter, LatticeRouterProvider } =
  createLatticeReact({ React, createGrid, createDataRouter });

Orders.tsx

// Orders.tsx
import React from 'react';
import { createRoot } from 'react-dom/client';
import { LatticeGrid, useLatticeRouter, LatticeRouterProvider } from './lattice';

const MONEY = { style: 'currency', currency: 'USD', decimals: 0 };
const orderColumns = [
  { field: 'id', title: 'Ref', layout: { width: 110, pin: 'start' } },
  { field: 'region', title: 'Region', filter: { type: 'set' } },
  { field: 'service', title: 'Service', filter: { type: 'set' } },
  { field: 'value', title: 'Value', type: 'number', format: MONEY, total: 'sum' },
];
const returnColumns = orderColumns.map((c) => (c.field === 'value' ? { ...c, title: 'Refund' } : c));

function Orders() {
  // Built once, in the effect useLatticeRouter runs, and destroyed with it:
  // rebuilding on every render would drop every attached grid and every row
  // it holds.
  const router = useLatticeRouter({ key: 'type', rowKey: 'id' });

  return (
    <LatticeRouterProvider router={router}>
      <div style={{ display: 'grid', gridTemplateColumns: '1fr 1fr', gap: 14 }}>
        <LatticeGrid
          route="order"
          rowKey="id"
          selection="multiple"
          highlightOnChange={{ duration: 500 }}
          columns={orderColumns}
          rows={[]}
          style={{ height: '320px' }}
        />
        <LatticeGrid
          route="return"
          rowKey="id"
          highlightOnChange={{ duration: 500 }}
          columns={returnColumns}
          rows={[]}
          style={{ height: '320px' }}
        />
      </div>
    </LatticeRouterProvider>
  );
}

createRoot(document.getElementById('orders')!).render(<Orders />);

See it running

Building…
Loading a live grid…

Open this demo's React tab →

Working in React

The router is scoped to where you build it. useLatticeRouter creates the router in an effect and destroys it in that effect's cleanup, so it returns null on the first render; every <LatticeGrid route="…"> beneath the matching <LatticeRouterProvider> attaches to it automatically by naming a route, with no ref passed down.

The config is read once. Rebuilding the router would drop every attached grid and every row it holds, so pass a router configuration you are not going to change on every render.

A grid still needs its own columns. The router moves rows by key; it does not decide what a grid displays, so each route's grid configures its own columns exactly as a standalone grid would, as returnColumns does above by adapting orderColumns.

Related